/*
     o[VՖʃNX

    2005/ 7/15 ˁ@P
*/
#include <windows.h>
#include "Bord.h"

CBord::CBord() {

	clear();

}

/* wՖʂRs[ */
bool CBord::assign(const CBord *lpbdSrc) {

	if (lpbdSrc == NULL) {
		return false;
	}

	if (lpbdSrc == this) {
		return true;
	}

	for (int i = 0;i < 8;i++) {
		for (int j = 0;j < 8;j++) {
			m_iCell[j][i] = lpbdSrc->m_iCell[j][i];
		}
	}

	return true;

}


void CBord::clear() {

	for (int i = 0;i < 8;i++) {
		for (int j = 0;j < 8;j++) {
			m_iCell[j][i] = 0;
		}
	}

}

/* VQ[ */
void CBord::newGame() {

	clear();

	/* zu */
	m_iCell[3][3] = -1;
	m_iCell[4][3] = 1;
	m_iCell[3][4] = 1;
	m_iCell[4][4] = -1;

}

int CBord::getCell(int iX, int iY) const {

	if (iX < 0 || iX > 7 || iY < 0 || iY > 7) {
		return 0;
	}

	return m_iCell[iX][iY];

}

int CBord::getBlackNum() const {

	int iBlack = 0;

	for (int i = 0;i < 8;i++) {
		for (int j = 0;j < 8;j++) {
			if (getCell(j, i) == 1) {
				iBlack++;
			}
		}
	}

	return iBlack;

}

int CBord::getWhiteNum() const {

	int iWhite = 0;

	for (int i = 0;i < 8;i++) {
		for (int j = 0;j < 8;j++) {
			if (getCell(j, i) == -1) {
				iWhite++;
			}
		}
	}

	return iWhite;

}

/* Ֆʕ]iwԂ̋̂݁j */
int CBord::getScore1(int iCell) {

	int iScore = 0;
	int i, j;

	if (m_iCell[0][0] == iCell) {
		iScore += 250;
	}

	if (m_iCell[7][0] == iCell) {
		iScore += 250;
	}

	if (m_iCell[0][7] == iCell) {
		iScore += 250;
	}

	if (m_iCell[7][7] == iCell) {
		iScore += 250;
	}

	for (i = 0;i < 8;i++) {

		if (m_iCell[i][0] == iCell) {
			iScore += 10;
		}

		if (m_iCell[0][i] == iCell) {
			iScore += 10;
		}

		if (m_iCell[i][7] == iCell) {
			iScore += 10;
		}

		if (m_iCell[7][i] == iCell) {
			iScore += 10;
		}

	}

	for (i = 1;i < 7;i++) {
		for (j = 1;j < 7;j++) {
			if (m_iCell[7][i] == iCell) {
				iScore += 2;
			}
		}
	}

	if (m_iCell[0][0] == 0) {

		if (m_iCell[0][1] == iCell) {
			iScore -= 20;
		}

		if (m_iCell[1][0] == iCell) {
			iScore -= 20;
		}

		if (m_iCell[1][1] == iCell) {
			iScore -= 10;
		}

	}

	if (m_iCell[7][0] == 0) {

		if (m_iCell[7][1] == iCell) {
			iScore -= 20;
		}

		if (m_iCell[6][0] == iCell) {
			iScore -= 20;
		}

		if (m_iCell[6][1] == iCell) {
			iScore -= 10;
		}

	}

	if (m_iCell[0][7] == 0) {

		if (m_iCell[0][6] == iCell) {
			iScore -= 20;
		}

		if (m_iCell[1][7] == iCell) {
			iScore -= 20;
		}

		if (m_iCell[1][6] == iCell) {
			iScore -= 10;
		}

	}

	if (m_iCell[7][7] == 0) {

		if (m_iCell[6][7] == iCell) {
			iScore -= 20;
		}

		if (m_iCell[7][6] == iCell) {
			iScore -= 20;
		}

		if (m_iCell[6][6] == iCell) {
			iScore -= 10;
		}

	}

	return iScore;

}

/* Ֆʕ] */
int CBord::getScore(int iCell) {

	return getScore1(iCell) - getScore1(-iCell);

}

bool CBord::putCell(int iX, int iY, int iCell) {

	if (!testCell(iX, iY, iCell)) {
		return false;
	}

	for (int i = -1;i < 2;i++) {
		for (int j = -1;j < 2;j++) {
			reverse(iX, iY, j, i, iCell);
		}
	}

	m_iCell[iX][iY] = iCell;
	
	return true;

}

/* iiX, iYjɐ΂u邩 */
bool CBord::testCell(int iX, int iY, int iCell) const {

	if (iX < 0 || iX > 7 || iY < 0 || iY > 7 ||
	    (iCell != 1 && iCell != -1)) {
		return false;
	}

	for (int i = -1;i < 2;i++) {
		for (int j = -1;j < 2;j++) {
			if (ren(iX, iY, j, i, iCell) > 0) {
				return true;
			}
		}
	}

	return false;

}

int CBord::ren(int iX, int iY, int iDx, int iDy, int iCell) const {

	int xx, yy, n = 0;

	xx = iX + iDx;
	yy = iY + iDy;

	if (xx < 0 || xx > 7 || yy < 0 || yy > 7 || (iDx == 0 && iDy == 0) ||
		m_iCell[iX][iY] != 0 || m_iCell[xx][yy] != -iCell) {
		return 0;
	}

	while (xx >= 0 && xx < 8 && yy >= 0 && yy < 8 && m_iCell[xx][yy] == -iCell) {

		xx += iDx;
		yy += iDy;

		n++;

	}

	if (xx >= 0 && xx < 8 && yy >= 0 && yy < 8 && m_iCell[xx][yy] == iCell)
		return n;
	else
		return 0;

}

int CBord::reverse(int iX, int iY, int iDx, int iDy, int iCell) {

	int n = ren(iX, iY, iDx, iDy, iCell);

	for (int i = 0;i < n;i++) {

		iX += iDx;
		iY += iDy;

		m_iCell[iX][iY] = iCell;

	}

	return n;

}

int CBord::testBord(int iTurn) const {

	int iNum = 0;

	for (int i = 0;i < 8;i++) {
		for (int j = 0;j < 8;j++) {
			if (testCell(j, i, iTurn)) {
				iNum++;
			}
		}
	}

	return iNum;

}
