/*
     o[V 04

   2005/ 7/19 ˁ@P
*/

#include <windows.h>
#include "Bord.h"
#include <process.h>
#include <time.h>

#define IDM_START 1
#define IDM_STOP  2

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK BordWndProc(HWND, UINT, WPARAM, LPARAM);

void newGame();
void drawCell();
bool comp(int iTurn);

unsigned WINAPI gameThread(void *lpData);

HINSTANCE g_hInstance;

HWND g_hwMain, g_hwBord;
HWND g_hwBlack, g_hwWhite, g_hwStart, g_hwStop;

CBord g_bord;

HBITMAP g_hbmpBord, g_hbmpBordOld, g_hbmpBlack, g_hbmpWhite, g_hbmpBlackOld, g_hbmpWhiteOld;
HDC g_hdcBord, g_hdcBlack, g_hdcWhite;

HANDLE g_hGameThread;
DWORD g_dwThreadID;

volatile int g_iState;
volatile bool g_bStop;

int g_aPlayer[2];

/* \ */
struct SItem {

	int iX, iY, iScore;

};

int g_info[64];
int g_iMX, g_iMY;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow) {

	MSG msg;
	WNDCLASSEX wndclass;

	RECT rec = {0, 0, 288, 392};
	
	g_hInstance = hInstance;

	g_iMX = -1;
	g_iMY = -1;

	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = NULL;
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "REVS";
	wndclass.hIconSm       = NULL;

	RegisterClassEx(&wndclass);

	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = BordWndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = NULL;
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "BORDWND";
	wndclass.hIconSm       = NULL;

	RegisterClassEx(&wndclass);

	/* CEChENCAgTCYZo */
    AdjustWindowRect(&rec, WS_OVERLAPPEDWINDOW, FALSE);

	/* CEChE쐬 */
	g_hwMain = CreateWindow ("REVS", "o[V 04", WS_OVERLAPPEDWINDOW | WS_VISIBLE,
	  CW_USEDEFAULT, CW_USEDEFAULT,
	  rec.right - rec.left, rec.bottom - rec.top,
	  NULL, NULL, hInstance, NULL);

	ShowWindow(g_hwMain, iCmdShow);

	/* bZ[W[v */
	while (GetMessage(&msg, NULL, 0, 0)) {

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return (int)msg.wParam;

}

/* Q[Xbh֐ */
unsigned WINAPI gameThread(void *lpData) {

	srand((unsigned)time(NULL));

	while (g_iState != 4) {

		switch (g_iState) {

		/* ̔ */
		case 1:

			if (g_bord.testBord(1) == 0) {
				g_iState = -1;
			} else {

				/* CPU */
				if (g_aPlayer[0] > 0) {

					for (int i = 0;i < 64;i++) {
						g_info[i] = 0;
					}

					Sleep(100);

					if (comp(g_iState)) {
					}

					g_iState = -1;

					drawCell();

				} else {

					/* łĂZ̏ݒ */
					for (int i = 0;i < 8;i++) {
						for (int j = 0;j < 8;j++) {
							if (g_bord.testCell(j, i, 1)) {
								g_info[j + i * 8] = 1;
							} else {
								g_info[j + i * 8] = 0;
							}
						}
					}

					drawCell();

				}

				InvalidateRect(g_hwBord, NULL, FALSE);

			}

			/* Q[ItO */
			if (g_bStop) {

				g_iState = 0;

				g_bStop = false;

			}

			break;

		/* ̔ */
		case -1:

			if (g_bord.testBord(-1) == 0) {
				g_iState = 1;
			} else {

				/* CPU */
				if (g_aPlayer[1] > 0) {

					for (int i = 0;i < 64;i++) {
						g_info[i] = 0;
					}

					Sleep(100);

					if (comp(g_iState)) {
					}

					g_iState = 1;

					drawCell();

				} else {

					for (int i = 0;i < 8;i++) {
						for (int j = 0;j < 8;j++) {
							if (g_bord.testCell(j, i, -1)) {
								g_info[j + i * 8] = 1;
							} else {
								g_info[j + i * 8] = 0;
							}
						}
					}

					drawCell();

				}

				InvalidateRect(g_hwBord, NULL, FALSE);

			}

			/* Q[ItO */
			if (g_bStop) {

				g_iState = 0;

				g_bStop = false;

			}

			break;

		}

		/* ґłȂ */
		if ((g_iState == 1 || g_iState == -1) &&
		     g_bord.testBord(1) == 0 && g_bord.testBord(-1) == 0) {

			if (g_bord.getBlackNum() > g_bord.getWhiteNum()) { 
				MessageBox(g_hwMain, "Q[IB̏I", "mF", MB_OK);
			}

			if (g_bord.getWhiteNum() > g_bord.getBlackNum()) { 
				MessageBox(g_hwMain, "Q[IB̏I", "mF", MB_OK);
			}

			if (g_bord.getBlackNum() == g_bord.getWhiteNum()) { 
				MessageBox(g_hwMain, "Q[IBI", "mF", MB_OK);
			}

			g_iState = 0;

		}

		Sleep(10);

	}

	return 0;

}

void newGame() {

	g_bord.newGame();

	drawCell();

	InvalidateRect(g_hwMain, NULL, FALSE);

}

/* ǂ݂Lȏ󋵂ɂȂ悤I */
POINT AI1(int iTurn, const CBord *bdArg) {

	POINT ptTmp;

	ptTmp.x = -1;
	ptTmp.y = -1;

	if (bdArg == NULL) {
		return ptTmp;
	}

	SItem aptCell[60];
	int iPoint = 0;

	int i, j;

	/* \Ȏ */
	for (i = 0;i < 8;i++) {
		for (j = 0;j < 8;j++) {
			if (bdArg->testCell(j, i, iTurn)) {

				aptCell[iPoint].iX = j;
				aptCell[iPoint].iY = i;

				CBord bdTmp;
				bdTmp.assign(bdArg);

				bdTmp.putCell(j, i, iTurn);

				/* ̕]L^ */
				aptCell[iPoint].iScore = bdTmp.getScore(iTurn);

				iPoint++;

			}
		}
	}

	if (iPoint == 0) {
		return ptTmp;
	}

	int iMax = aptCell[0].iScore;

	/* \Ȏ̃XgLȏɍ~\[g */
	for (i = 0;i < iPoint - 1;i++) {
		for (j = i + 1; j < iPoint;j++) {
			if (aptCell[j].iScore > aptCell[i].iScore) {

				SItem tmp = aptCell[j];

				aptCell[j] = aptCell[i];
				aptCell[i] = tmp;

				if (aptCell[j].iScore > iMax) {
					iMax = aptCell[j].iScore;
				}

			}
		}
	}

	int iMaxs = 0;

	/* ƂLȎ̐JEg */
	for (i = 0;i < iPoint;i++) {
		if (aptCell[i].iScore == iMax) {
			iMaxs++;
		}
	}

	/* ƂLȎ肩I */
	int iIndex = rand() % iMaxs;

	ptTmp.x = aptCell[iIndex].iX;
	ptTmp.y = aptCell[iIndex].iY;

	return ptTmp;

}

/* ȋ̎j\A */
POINT AI2(int iTurn, const CBord *lpbdArg) {

	POINT ptTmp;

	ptTmp.x = -1;
	ptTmp.y = -1;

	if (lpbdArg == NULL) {
		return ptTmp;
	}

	SItem aptCell[60];
	int iPoint = 0;

	int i, j;

	/* \Ȏ */
	for (i = 0;i < 8;i++) {
		for (j = 0;j < 8;j++) {
			if (lpbdArg->testCell(j, i, iTurn)) {

				aptCell[iPoint].iX = j;
				aptCell[iPoint].iY = i;

				/* ƗpՖʂɌ݂̏Ԃݒ */
				CBord bdTmp;
				bdTmp.assign(lpbdArg);

				bdTmp.putCell(j, i, iTurn);

				/* ̎\ */
				ptTmp = AI1(-iTurn, &bdTmp);

				if (ptTmp.x >= 0) {
					bdTmp.putCell(ptTmp.x, ptTmp.y, -iTurn);
				}

				/* ̕]L^ */
				aptCell[iPoint].iScore = bdTmp.getScore(iTurn);

				iPoint++;

			}
		}
	}

	if (iPoint == 0) {
		return ptTmp;
	}

	int iMax = aptCell[0].iScore;

	/* \Ȏ̃XgLȏɍ~\[g */
	for (i = 0;i < iPoint - 1;i++) {
		for (j = i + 1; j < iPoint;j++) {
			if (aptCell[j].iScore > aptCell[i].iScore) {

				SItem tmp = aptCell[j];

				aptCell[j] = aptCell[i];
				aptCell[i] = tmp;

				if (aptCell[j].iScore > iMax) {
					iMax = aptCell[j].iScore;
				}

			}
		}
	}

	int iMaxs = 0;

	/* ƂLȎ̐JEg */
	for (i = 0;i < iPoint;i++) {
		if (aptCell[i].iScore == iMax) {
			iMaxs++;
		}
	}

	/* ƂLȎ肩I */
	int iIndex = rand() % iMaxs;

	ptTmp.x = aptCell[iIndex].iX;
	ptTmp.y = aptCell[iIndex].iY;

	return ptTmp;

}

POINT AI3(int iTurn, const CBord *lpbdArg) {

	POINT ptTmp;

	ptTmp.x = -1;
	ptTmp.y = -1;

	if (lpbdArg == NULL) {
		return ptTmp;
	}

	SItem aptCell[60];
	int iPoint = 0;

	int i, j;

	/* \Ȏ */
	for (i = 0;i < 8;i++) {
		for (j = 0;j < 8;j++) {
			if (lpbdArg->testCell(j, i, iTurn)) {

				aptCell[iPoint].iX = j;
				aptCell[iPoint].iY = i;

				CBord bdTmp;
				bdTmp.assign(lpbdArg);

				bdTmp.putCell(j, i, iTurn);

				ptTmp = AI1(-iTurn, &bdTmp);

				if (ptTmp.x >= 0) {

					bdTmp.putCell(ptTmp.x, ptTmp.y, -iTurn);

					ptTmp = AI1(iTurn, &bdTmp);

					if (ptTmp.x >= 0) {

						bdTmp.putCell(ptTmp.x, ptTmp.y, iTurn);

					}

				}

				aptCell[iPoint].iScore = bdTmp.getScore(iTurn);

				iPoint++;

			}
		}
	}

	if (iPoint == 0) {
		return ptTmp;
	}

	int iMax = aptCell[0].iScore;

	/* \Ȏ̃XgLȏɍ~\[g */
	for (i = 0;i < iPoint - 1;i++) {
		for (j = i + 1; j < iPoint;j++) {
			if (aptCell[j].iScore > aptCell[i].iScore) {

				SItem tmp = aptCell[j];

				aptCell[j] = aptCell[i];
				aptCell[i] = tmp;

				if (aptCell[j].iScore > iMax) {
					iMax = aptCell[j].iScore;
				}

			}
		}
	}

	int iMaxs = 0;

	/* ƂLȎ̐JEg */
	for (i = 0;i < iPoint;i++) {
		if (aptCell[i].iScore == iMax) {
			iMaxs++;
		}
	}

	/* ƂLȎ肩I */
	int iIndex = rand() % iMaxs;

	ptTmp.x = aptCell[iIndex].iX;
	ptTmp.y = aptCell[iIndex].iY;

	return ptTmp;

}

/* Rs[^vl */
bool comp(int iTurn) {

	POINT ptComp;

	if (iTurn == 1) {

		switch (g_aPlayer[0]) {
		
		case 1:
	
			ptComp = AI1(iTurn, &g_bord);
		
			break;

		case 2:

			ptComp = AI2(iTurn, &g_bord);
		
			break;

		case 3:

			ptComp = AI3(iTurn, &g_bord);
		
			break;

		}

	}

	if (iTurn == -1) {

		switch (g_aPlayer[1]) {
		
		case 1:
	
			ptComp = AI1(iTurn, &g_bord);
		
			break;

		case 2:

			ptComp = AI2(iTurn, &g_bord);

		case 3:

			ptComp = AI3(iTurn, &g_bord);
		
			break;
	
			break;

		}

	}

	if (ptComp.x < 0) {
		return false;
	}

	g_bord.putCell(ptComp.x, ptComp.y, iTurn);

	drawCell();

	InvalidateRect(g_hwBord, NULL, FALSE);

	return true;

}

/* Ֆʕ` */
void drawCell() {

	int i, j;
	int iBlack = 0, iWhite = 0;

	HBRUSH br, brInfo;
	RECT rec = {0, 0, 288, 320};
	RECT recBlack = {54, 8, 100, 42};
	RECT recWhite = {194, 8, 340, 42};

	char aszTmp[8];

	RECT recFill;

	br = CreateSolidBrush(RGB(64, 128, 32));

	FillRect(g_hdcBord, &rec, br);

	DeleteObject(br);

	brInfo = CreateSolidBrush(RGB(144, 144, 160));

	SelectObject(g_hdcBord, (HPEN)GetStockObject(BLACK_PEN));

	for (i = 0;i < 9;i++) {

		MoveToEx(g_hdcBord, 16, 48 + i * 32, NULL);

		LineTo(g_hdcBord, 272, 48 + i * 32);

		MoveToEx(g_hdcBord, 16 + i * 32, 48, NULL);

		LineTo(g_hdcBord, 16 + i * 32, 304);

	}

	for (i = 0;i < 8;i++) {
		for (j = 0;j < 8;j++) {

			/* łĂꏊɃ}[N */
			if (g_info[j + i * 8] != 0) {

				recFill.left = j * 32 + 18;
				recFill.top = i * 32 + 50;
				recFill.right = j * 32 + 48;
				recFill.bottom = i * 32 + 80;

				FillRect(g_hdcBord, &recFill, brInfo);

			}

			switch (g_bord.getCell(j, i)) {

			case 1:

				SelectObject(g_hdcBord, GetStockObject(BLACK_BRUSH));

				Ellipse(g_hdcBord, j * 32 + 18, i * 32 + 50, j * 32 + 48, i * 32 + 80);

				iBlack++;

				break;

			case -1:

				SelectObject(g_hdcBord, GetStockObject(WHITE_BRUSH));

				Ellipse(g_hdcBord, j * 32 + 18, i * 32 + 50, j * 32 + 48, i * 32 + 80);

				iWhite++;

				break;

			}

		}
	}

	SelectObject(g_hdcBord, GetStockObject(BLACK_BRUSH));

	/* ŏi */
	Ellipse(g_hdcBord, 18, 10, 48, 40);

	wsprintf(aszTmp, "%d", iBlack);

	/* ̐` */
	DrawText(g_hdcBord, aszTmp, -1, &recBlack, DT_LEFT | DT_VCENTER | DT_SINGLELINE);

	SelectObject(g_hdcBord, GetStockObject(WHITE_BRUSH));

	/* ŏi */
	Ellipse(g_hdcBord, 158, 10, 188, 40);

	wsprintf(aszTmp, "%d", iWhite);

	/* ̐` */
	DrawText(g_hdcBord, aszTmp, -1, &recWhite, DT_LEFT | DT_VCENTER | DT_SINGLELINE);

	/* ̔ԂȂŏiۂԘgň͂ */
	if (g_iState == 1) {

		HPEN hp = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));

		SelectObject(g_hdcBord, hp);

		MoveToEx(g_hdcBord, 16, 8, NULL);
		LineTo(g_hdcBord, 50, 8);
		LineTo(g_hdcBord, 50, 42);
		LineTo(g_hdcBord, 16, 42);
		LineTo(g_hdcBord, 16, 8);

		SelectObject(g_hdcBord, (HPEN)GetStockObject(BLACK_PEN));

		DeleteObject(hp);

	}

	/* ̔ԂȂŏiۂԘgň͂ */
	if (g_iState == -1) {

		HPEN hp = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));

		SelectObject(g_hdcBord, hp);

		MoveToEx(g_hdcBord, 156, 8, NULL);
		LineTo(g_hdcBord, 190, 8);
		LineTo(g_hdcBord, 190, 42);
		LineTo(g_hdcBord, 156, 42);
		LineTo(g_hdcBord, 156, 8);

		SelectObject(g_hdcBord, (HPEN)GetStockObject(BLACK_PEN));

		DeleteObject(hp);

	}

	if (g_iMX >= 0) {

		HPEN hp;

		if (g_info[g_iMX + g_iMY * 8] == 1) {
			hp = CreatePen(PS_SOLID, 2, RGB(0, 0, 255));
		} else {
			hp = CreatePen(PS_SOLID, 2, RGB(255, 0, 0));
		}

		SelectObject(g_hdcBord, hp);

		MoveToEx(g_hdcBord, g_iMX * 32 + 18, g_iMY * 32 + 50, NULL);
		LineTo(g_hdcBord, g_iMX * 32 + 48, g_iMY * 32 + 50);
		LineTo(g_hdcBord, g_iMX * 32 + 48, g_iMY * 32 + 80);
		LineTo(g_hdcBord, g_iMX * 32 + 18, g_iMY * 32 + 80);
		LineTo(g_hdcBord, g_iMX * 32 + 18, g_iMY * 32 + 50);

		SelectObject(g_hdcBord, (HPEN)GetStockObject(BLACK_PEN));

		DeleteObject(hp);

	}

	DeleteObject(brInfo);

}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	RECT rec = {0, 0, 32, 32};

	HDC hdc;
	PAINTSTRUCT ps;

	switch (iMsg) {

	case WM_CREATE:

		g_hwBord = CreateWindow("BORDWND", NULL,WS_CHILD | WS_VISIBLE,
		  0, 40, 288, 320, hwnd, NULL, g_hInstance, NULL);

		g_hwBlack = CreateWindow("COMBOBOX", NULL, WS_CHILD | WS_VISIBLE | CBS_DROPDOWN,
		                        40, 4, 96, 128, hwnd, (HMENU)0, g_hInstance, NULL);

		SendMessage(g_hwBlack, CB_ADDSTRING, -1, (LPARAM)"l");
		SendMessage(g_hwBlack, CB_ADDSTRING, -1, (LPARAM)"CPU Lv1");
		SendMessage(g_hwBlack, CB_ADDSTRING, -1, (LPARAM)"CPU Lv2");
		SendMessage(g_hwBlack, CB_ADDSTRING, -1, (LPARAM)"CPU Lv3");

		SendMessage(g_hwBlack, CB_SETCURSEL, 0, 1);

		g_hwWhite = CreateWindow("COMBOBOX", NULL, WS_CHILD | WS_VISIBLE | CBS_DROPDOWN,
		                        180, 4, 96, 128, hwnd, (HMENU)0, g_hInstance, NULL);

		SendMessage(g_hwWhite, CB_ADDSTRING, -1, (LPARAM)"l");
		SendMessage(g_hwWhite, CB_ADDSTRING, -1, (LPARAM)"CPU Lv1");
		SendMessage(g_hwWhite, CB_ADDSTRING, -1, (LPARAM)"CPU Lv2");
		SendMessage(g_hwWhite, CB_ADDSTRING, -1, (LPARAM)"CPU Lv3");

		SendMessage(g_hwWhite, CB_SETCURSEL, 1, 2);

		g_hwStart = CreateWindow("BUTTON", "Q[Jn", WS_CHILD | WS_VISIBLE,
		                        4, 362, 100, 28, hwnd, (HMENU)IDM_START, g_hInstance, NULL);

		g_hwStop = CreateWindow("BUTTON", "Q[I", WS_CHILD | WS_VISIBLE,
		                        124, 362, 100, 28, hwnd, (HMENU)IDM_STOP, g_hInstance, NULL);

		hdc = GetDC(hwnd);

		g_hbmpBlack = CreateCompatibleBitmap(hdc, 32, 32);
		g_hdcBlack = CreateCompatibleDC(hdc);
		g_hbmpBlackOld = SelectObject(g_hdcBlack, g_hbmpBlack);

		g_hbmpWhite = CreateCompatibleBitmap(hdc, 32, 32);
		g_hdcWhite = CreateCompatibleDC(hdc);
		g_hbmpWhiteOld = SelectObject(g_hdcWhite, g_hbmpWhite);

		ReleaseDC(hwnd, hdc);

		FillRect(g_hdcBlack, &rec, (HBRUSH)GetStockObject(WHITE_BRUSH));

		SelectObject(g_hdcBlack, GetStockObject(BLACK_PEN));
		SelectObject(g_hdcBlack, GetStockObject(BLACK_BRUSH));

		Ellipse(g_hdcBlack, 2, 2, 31, 31);

		FillRect(g_hdcWhite, &rec, (HBRUSH)GetStockObject(WHITE_BRUSH));

		SelectObject(g_hdcWhite, GetStockObject(BLACK_PEN));
		SelectObject(g_hdcWhite, GetStockObject(WHITE_BRUSH));

		Ellipse(g_hdcWhite, 2, 2, 31, 31);

		return 0;

	case WM_COMMAND:

		switch(LOWORD(wParam)) {

		case IDM_START:

			if (g_iState == 0) {

				newGame();

				g_aPlayer[0] = SendMessage(g_hwBlack, CB_GETCURSEL, 0, 0);

				g_aPlayer[1] = SendMessage(g_hwWhite, CB_GETCURSEL, 0, 0);

				g_iState = 1;
				g_bStop = false;

				drawCell();

				InvalidateRect(hwnd, NULL, FALSE);

			}

			break;

		case IDM_STOP:

			if (g_iState == 0) {
				break;
			}

			g_bStop = true;

			while (g_bStop) {
				Sleep(1);
			}

			drawCell();

			InvalidateRect(hwnd, NULL, FALSE);

			break;

		}

		return 0;

	case WM_PAINT:

		hdc = BeginPaint(hwnd,&ps);

		BitBlt(hdc, 0, 0, 32, 32, g_hdcBlack, 0, 0, SRCCOPY);
		BitBlt(hdc, 140, 0, 32, 32, g_hdcWhite, 0, 0, SRCCOPY);

		EndPaint(hwnd, &ps);

		return 0;

	case WM_DESTROY: /* I */

		/* XbhItOZbg */
		g_iState = 4;

		/* Q[XbhIҋ@ */
		WaitForSingleObject(g_hGameThread, 2000);

		CloseHandle(g_hGameThread);

		SelectObject(g_hdcBlack, g_hbmpBlackOld);

		DeleteObject(g_hbmpBlack);
		DeleteDC(g_hdcBlack);

		SelectObject(g_hdcWhite, g_hbmpWhiteOld);

		DeleteObject(g_hbmpWhite);
		DeleteDC(g_hdcWhite);

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

/* ՖʃEChE */
LRESULT CALLBACK BordWndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;

	int iCX, iCY;

	switch (iMsg) {

	case WM_CREATE:

		hdc = GetDC(hwnd);

		g_hbmpBord = CreateCompatibleBitmap(hdc, 288, 320);
		g_hdcBord = CreateCompatibleDC(hdc);

		SetBkMode(g_hdcBord, TRANSPARENT);

		g_hbmpBordOld = SelectObject(g_hdcBord, g_hbmpBord);

		ReleaseDC(hwnd, hdc);

		g_bord.newGame();

		drawCell();

		g_aPlayer[0] = 0;
		g_aPlayer[1] = 1;

		g_iState = 0;

		g_hGameThread = (HANDLE)_beginthreadex(NULL, 0, gameThread, NULL, 0, (unsigned int *)&g_dwThreadID);

		return 0;

	case WM_MOUSEMOVE:

		iCX = ((int)LOWORD(lParam) - 16) / 32;
		iCY = ((int)HIWORD(lParam) - 48) / 32;

		if (iCX < 0 || iCX > 7 || iCY < 0 || iCY > 7) {

			g_iMX = -1;

			return 0;

		}

		g_iMX = iCX;
		g_iMY = iCY;

		drawCell();

		InvalidateRect(g_hwBord, NULL, FALSE);

		return 0;

	case WM_LBUTTONUP:

		iCX = ((int)LOWORD(lParam) - 16) / 32;
		iCY = ((int)HIWORD(lParam) - 48) / 32;

		if (iCX < 0 || iCX > 7 || iCY < 0 || iCY > 7) {
			return 0;
		}

		switch (g_iState) {

		case 1:

			if (g_aPlayer[0] == 0 && g_bord.testCell(iCX, iCY, g_iState)) {

				g_bord.putCell(iCX, iCY, g_iState);

				g_iState = -1;

				drawCell();

				InvalidateRect(hwnd, NULL, FALSE);

			}

			break;

		case -1:

			if (g_aPlayer[1] == 0 && g_bord.testCell(iCX, iCY, g_iState)) {

				g_bord.putCell(iCX, iCY, g_iState);

				g_iState = 1;

				drawCell();

				InvalidateRect(hwnd, NULL, FALSE);

			}


		}

		return 0;

	case WM_PAINT:

		hdc = BeginPaint(hwnd,&ps);

		BitBlt(hdc, 0, 0, 288, 320, g_hdcBord, 0, 0, SRCCOPY);

		EndPaint(hwnd, &ps);

		return 0;

	case WM_DESTROY: /* I */

		SelectObject(g_hdcBord, g_hbmpBordOld);

		DeleteObject(g_hbmpBord);
		DeleteDC(g_hdcBord);

		return 0;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}
